#! /usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var https_1 = __importDefault(require("https"));
var child_process_1 = __importDefault(require("child_process"));
var tar_1 = __importDefault(require("tar"));
var adm_zip_1 = __importDefault(require("adm-zip"));
var chars = [
    '⡀',
    '⡄',
    '⡆',
    '⡇',
    '⡏',
    '⡟',
    '⡿',
    '⣿'
];
var updatesPerSecond = 333;
function parseArgs(args) {
    var obj = {
        double: {},
        single: {},
    };
    for (var i = 0; i < args.length; i++) {
        var arg = args[i];
        if (arg.startsWith('--')) {
            var key = arg.slice(2);
            if (key.includes('=')) {
                var _a = key.split('='), k = _a[0], v = _a.slice(1);
                obj.double[k] = v.join('=');
            }
            else if (args[i + 1] && !args[i + 1].startsWith('-')) {
                obj.double[key] = args[i + 1];
                i++;
            }
            else {
                obj.double[key] = true;
            }
        }
        else if (arg.startsWith('-')) {
            var key = arg.slice(1);
            if (key.includes('=')) {
                var _b = key.split('='), k = _b[0], v = _b.slice(1);
                obj.single[k] = v.join('=');
            }
            else if (args[i + 1] && !args[i + 1].startsWith('-')) {
                obj.single[key] = args[i + 1];
                i++;
            }
            else {
                obj.single[key] = true;
            }
        }
    }
    return obj;
}
function handleRes(response, filename, file) {
    var maxLength = parseInt(response.headers['content-length'] || '0', 10);
    console.log("Downloading ".concat(filename, " (").concat(maxLength, " bytes)"));
    var maxDownloadStatusLen = Math.round(process.stdout.columns - "Downloading ".concat(filename, "... ").length) - (3 + ("".concat(maxLength, " ").length * 2) + ' 100%'.length);
    var resizeFn = function () {
        maxDownloadStatusLen = Math.round(process.stdout.columns - "Downloading ".concat(filename, "... ").length) - (3 + ("".concat(maxLength, " ").length * 2) + ' 100%'.length);
        process.stdout.cursorTo(0);
        process.stdout.clearLine(1);
        process.stdout.write("Downloading ".concat(filename, "... ["));
    };
    process.stdout.on('resize', resizeFn);
    response.pipe(file);
    process.stdout.write("Downloading ".concat(filename, "... ["));
    var progress = 0;
    var dlen = "Downloading ".concat(filename, "... [").length;
    var chunkSize = Math.floor(maxLength / maxDownloadStatusLen);
    var finalchar = chars[chars.length - 1];
    var progressInterval = setInterval(function () {
        if (maxDownloadStatusLen < 10) {
            process.stdout.cursorTo(0);
            process.stdout.clearLine(1);
            process.stdout.write("Downloading ".concat(filename, "... ").concat(Math.round(progress * 100).toString().padStart(3, ' '), "% (").concat(file.bytesWritten, "/").concat(maxLength, ")"));
        }
        else {
            process.stdout.cursorTo(dlen);
            var char = chars[Math.floor(((file.bytesWritten % chunkSize) / chunkSize) * chars.length)];
            process.stdout.write("".concat(finalchar.repeat(Math.max(0, (progress * maxDownloadStatusLen) - 1))).concat(char).concat('-'.repeat(maxDownloadStatusLen - progress * maxDownloadStatusLen), "] ").concat(Math.round(progress * 100).toString().padStart(3, ' '), "% (").concat(file.bytesWritten, "/").concat(maxLength, ")"));
        }
    }, 1000 / updatesPerSecond);
    response.on('data', function () {
        progress = (file.bytesWritten / maxLength);
    });
    response.on('end', function () {
        clearInterval(progressInterval);
        process.stdout.removeListener('resize', resizeFn);
        process.stdout.cursorTo(0);
        process.stdout.clearLine(1);
        process.stdout.write("Downloaded ".concat(filename, " (").concat(maxLength, " bytes)\n\n"));
    });
}
function getVersions(build) {
    if (build && !['stable', 'insiders'].includes(build)) {
        return Promise.reject(new Error('Invalid build type'));
    }
    return new Promise(function (resolve, reject) {
        var req = https_1.default.get("https://code.visualstudio.com/sha".concat(build ? "?build=".concat(build) : ''), function (res) {
            var data = '';
            res.on('data', function (chunk) {
                data += chunk;
            });
            res.on('end', function () {
                try {
                    resolve(JSON.parse(data).products);
                }
                catch (err) {
                    reject(err);
                }
            });
        });
        req.on('error', function (err) {
            reject(err);
        });
    });
}
var args = parseArgs(process.argv.slice(2));
var double = args.double, single = args.single;
var action = double['download']
    ? 'download' :
    double['install']
        ? 'install' :
        double['link']
            ? 'link' :
            double['help']
                ? 'help' :
                double['action'] || single['a'] || 'download';
if (typeof action !== 'string') {
    console.error('Invalid action');
    process.exit(1);
}
if (![
    'download',
    'install',
    'link',
    'update',
    'help',
    'versions'
].includes(action)) {
    console.error("Invalid action: ".concat(action));
    process.exit(1);
}
var sections = {
    sections: [
        {
            keys: ['--help', '-h'],
            description: 'Show this help message',
        },
        {
            keys: ['--section', '-s'],
            description: function () { return 'Show a specific section. Can be one of: ' + Object.keys(sections).join(', '); },
        },
    ],
    main: [
        {
            keys: [
                '--action',
                '-a'
            ],
            description: 'The action to perform. Can be one of download, install, link, update, or help',
            required: false,
            default: 'download'
        }
    ],
    download: [
        {
            keys: [
                '--build',
                '-b'
            ],
            description: 'The build to download. Can either be stable or insiders',
            required: false,
            default: 'stable'
        },
        {
            keys: [
                '--filename',
                '-f'
            ],
            description: 'The filename to download to',
            required: false,
            default: 'vscode-{build}-{platform}-{arch}.{ext (tar.gz or zip)}'
        },
        {
            keys: [
                '--download-directory',
                '-d'
            ],
            description: 'The directory the file will be downloaded to',
            required: false,
            default: 'cwd/downloads'
        }
    ],
    install: [
        {
            keys: [
                '--file',
                '-f'
            ],
            description: 'The file to install from',
            required: true
        },
        {
            keys: [
                '--insiders',
                '-i'
            ],
            description: 'Install as insiders build (this option overrides --build or -b)',
            required: false
        },
        {
            keys: [
                '--stable',
                '-s'
            ],
            description: 'Install as stable build (this option overrides --build or -b)',
            required: false
        },
        {
            keys: [
                '--build',
                '-b'
            ],
            description: 'The build to install. Can either be stable or insiders',
            required: false,
            default: 'stable'
        },
        {
            keys: [
                '--install-directory',
                '-d'
            ],
            description: 'The directory to install to',
            required: false,
            default: process.platform === 'win32'
                ? '"C:\\Program Files\\Microsoft VS Code" or "C:\\Program Files\\Microsoft VS Code Insiders"'
                : process.platform === 'darwin'
                    ? '/Applications/Visual Studio Code or /Applications/Visual Studio Code - Insiders'
                    : '/usr/share/code or /usr/share/code-insiders'
        }
    ],
    link: [
        {
            keys: [
                '--build',
                '-b'
            ],
            description: 'The build to link. Can either be stable or insiders',
            required: false,
            default: 'stable'
        },
        {
            keys: [
                '--install-directory',
                '-d'
            ],
            description: 'The directory to link from',
            required: false,
            default: process.platform === 'darwin'
                ? '/Applications/Visual Studio Code or /Applications/Visual Studio Code - Insiders'
                : '/usr/share/code or /usr/share/code-insiders'
        },
        {
            keys: [
                '--symlink-directory',
                '-s'
            ],
            description: 'The directory to link to',
            required: false,
            default: process.platform === 'linux'
                ? '/usr/bin'
                : path_1.default.join(process.env.HOME, 'bin')
        }
    ],
    update: [
        {
            keys: [
                '--build',
                '-b'
            ],
            description: 'The build to update. Can either be stable or insiders',
            required: false,
            default: 'stable'
        },
        {
            keys: [
                '--install-directory',
                '-d'
            ],
            description: 'The directory to update',
            required: false,
            default: process.platform === 'win32'
                ? '"C:\\Program Files\\Microsoft VS Code" or "C:\\Program Files\\Microsoft VS Code Insiders"'
                : process.platform === 'darwin'
                    ? '/Applications/Visual Studio Code or /Applications/Visual Studio Code - Insiders'
                    : '/usr/share/code or /usr/share/code-insiders'
        }
    ],
    versions: [
        {
            keys: [
                '--build',
                '-b'
            ],
            description: 'The build to get versions for. Can either be stable, insiders, or all',
            required: false,
            default: 'all'
        }
    ]
};
function printSection(sectionName) {
    var section = sections[sectionName];
    console.log(sectionName);
    for (var _i = 0, section_1 = section; _i < section_1.length; _i++) {
        var _a = section_1[_i], keys = _a.keys, description = _a.description, required = _a.required, def = _a.default;
        console.log("  ".concat(keys.join(', '), ":").concat(required ? ' (required)' : '').concat(def ? " (default: ".concat(def, ")") : ''));
        for (var _b = 0, _c = (typeof description === 'string'
            ? description
            : description()).split('\n'); _b < _c.length; _b++) {
            var line = _c[_b];
            console.log("    ".concat(line));
        }
    }
    console.log();
}
function helpAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        var section, _i, _a, sectionName;
        return __generator(this, function (_b) {
            section = double['section'] || single['s'] || 'all';
            if (typeof section !== 'string') {
                console.error('Invalid section. If you want to see the sections, use --section=sections, -s=sections, or don\'t specify a section');
                process.exit(1);
            }
            switch (section) {
                case 'all':
                    console.log('All sections:');
                    console.log();
                    for (_i = 0, _a = Object.keys(sections); _i < _a.length; _i++) {
                        sectionName = _a[_i];
                        printSection(sectionName);
                    }
                    break;
                case 'sections':
                    printSection('sections');
                    break;
                case 'main':
                    printSection('main');
                    break;
                case 'download':
                    printSection('download');
                    break;
                case 'install':
                    printSection('install');
                    break;
                case 'link':
                    printSection('link');
                    break;
                case 'update':
                    printSection('update');
                    break;
                case 'versions':
                    printSection('versions');
                    break;
                default:
                    console.error("Invalid section: ".concat(section));
                    process.exit(1);
            }
            process.exit(0);
            return [2 /*return*/];
        });
    });
}
function getLatestVersion(build) {
    return __awaiter(this, void 0, void 0, function () {
        var _versions, versions, osname, platformVersion;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getVersions()];
                case 1:
                    _versions = _a.sent();
                    versions = _versions
                        .filter(function (_a) {
                        var _build = _a.build;
                        return _build === build;
                    });
                    osname = "linux-".concat(process.arch);
                    platformVersion = versions
                        .find(function (v) { return v.platform.os === osname; });
                    if (!platformVersion) {
                        console.error("No version found for ".concat(osname));
                        process.exit(1);
                    }
                    return [2 /*return*/, platformVersion.hash];
            }
        });
    });
}
function version(build, binpath) {
    if (build === void 0) { build = 'all'; }
    if (build === 'all') {
        return {
            stable: version('stable'),
            insiders: version('insiders')
        };
    }
    if (build !== 'stable' && build !== 'insiders') {
        throw new Error("Invalid build: ".concat(build));
    }
    if (build === 'stable') {
        binpath = binpath || child_process_1.default.execSync('which code').toString().trim();
        var version_1 = child_process_1.default.execSync("".concat(binpath, " --version")).toString().split('\n')[1].trim();
        return version_1;
    }
    else {
        binpath = binpath || child_process_1.default.execSync('which code-insiders').toString().trim();
        var packagejson = JSON.parse(fs_1.default.readFileSync(path_1.default.join(path_1.default.dirname(binpath), 'resources', 'app', 'package.json')).toString());
        var version_2 = packagejson.distro;
        return version_2;
    }
}
function downloadAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve) {
                    var build = double['build'] || single['b'] || 'stable';
                    if (typeof build !== 'string') {
                        console.error("Invalid build: ".concat(build));
                        process.exit(1);
                    }
                    if (!['stable', 'insiders'].includes(build)) {
                        console.error("Invalid build: ".concat(build));
                        process.exit(1);
                    }
                    var os = process.platform === 'win32'
                        ? "win32-".concat(process.arch, "-archive")
                        : process.platform === 'darwin'
                            ? 'darwin-universal'
                            : process.platform === 'linux'
                                ? "linux-".concat(process.arch)
                                : 'unknown';
                    if (os === 'unknown') {
                        console.error("Unsupported platform: ".concat(process.platform));
                        process.exit(1);
                    }
                    var url = "https://code.visualstudio.com/sha/download?build=".concat(build === 'insiders' ? 'insider' : build, "&os=").concat(os);
                    var filename = double['filename'] || single['f'] || "vscode-".concat(build, "-").concat(os, "-").concat(Date.now(), ".").concat(process.platform === 'linux' ? 'tar.gz' : 'zip');
                    var downloadDir = double['download-directory'] || single['d'] || path_1.default.join(process.cwd(), 'downloads');
                    if (typeof filename !== 'string') {
                        console.error("Invalid filename: ".concat(filename));
                        process.exit(1);
                    }
                    if (typeof downloadDir !== 'string') {
                        console.error("Invalid download directory: ".concat(downloadDir));
                        process.exit(1);
                    }
                    var downloadPath = path_1.default.join(downloadDir, filename);
                    if (!fs_1.default.existsSync(downloadDir)) {
                        fs_1.default.mkdirSync(downloadDir, { recursive: true });
                    }
                    console.log("Downloading ".concat(url, " to ").concat(downloadPath));
                    var file = fs_1.default.createWriteStream(downloadPath);
                    var request = https_1.default.get(url, function (response) {
                        if (response.statusCode === 302) {
                            console.log("Redirecting to ".concat(response.headers.location));
                            request.abort();
                            https_1.default.get(response.headers.location, function (response) {
                                handleRes(response, filename, file);
                            }).on('error', function (error) {
                                console.error(error);
                                process.exit(1);
                            }).on('end', function () {
                                console.log("Downloaded ".concat(filename));
                                process.exit(0);
                            });
                        }
                        else {
                            handleRes(response, filename, file);
                        }
                    });
                    file.on('finish', function () {
                        file.close();
                        console.log("\nDownloaded ".concat(filename, " to ").concat(downloadDir));
                        resolve(path_1.default.join(downloadDir, filename));
                    });
                    request.on('error', function (error) {
                        console.error(error);
                        process.exit(1);
                    });
                })];
        });
    });
}
function installAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        var file, build, dir, zip;
        return __generator(this, function (_a) {
            file = double['file'] || single['f'];
            build = double['insiders'] || single['i']
                ? 'insiders' :
                double['stable'] || single['s']
                    ? 'stable' :
                    double['build'] || single['b'] || 'stable';
            dir = double['install-directory'] || single['d'] || (process.platform === 'win32'
                ? path_1.default.join(process.env.LOCALAPPDATA, 'Programs', "Microsoft VS Code".concat(build === 'insiders' ? ' Insiders' : ''))
                : process.platform === 'darwin'
                    ? path_1.default.join(process.env.HOME, 'Applications', "Visual Studio Code".concat(build === 'insiders' ? ' - Insiders' : ''))
                    : "/usr/share/code".concat(build === 'insiders' ? '-insiders' : ''));
            if (typeof file !== 'string') {
                console.error("Invalid file: ".concat(file));
                process.exit(1);
            }
            if (typeof build !== 'string') {
                console.error("Invalid build: ".concat(build));
                process.exit(1);
            }
            if (typeof dir !== 'string') {
                console.error("Invalid install directory: ".concat(dir));
                process.exit(1);
            }
            if (!file) {
                console.error('Missing file');
                process.exit(1);
            }
            if (!fs_1.default.existsSync(file)) {
                console.error("File ".concat(file, " does not exist"));
                process.exit(1);
            }
            if (!fs_1.default.existsSync(dir)) {
                fs_1.default.mkdirSync(dir, { recursive: true });
            }
            if (process.platform === 'linux') {
                try {
                    fs_1.default.accessSync(dir, fs_1.default.constants.W_OK);
                }
                catch (error) {
                    console.error("Directory ".concat(dir, " is not writable, please run as root (sudo)"));
                    process.exit(1);
                }
                console.log("Installing ".concat(file, " to ").concat(dir));
                tar_1.default.x({
                    file: file,
                    cwd: dir,
                    strip: 1
                }).then(function () {
                    console.log("Installed ".concat(file, " to ").concat(dir));
                    process.exit(0);
                });
            }
            else {
                console.log("Installing ".concat(file, " to ").concat(dir));
                zip = new adm_zip_1.default(file);
                zip.extractAllTo(dir, true);
                console.log("Installed ".concat(file, " to ").concat(dir));
                process.exit(0);
            }
            return [2 /*return*/];
        });
    });
}
function linkAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        var build, dir, bindir, symlinkdir;
        return __generator(this, function (_a) {
            build = double['build'] || single['b'] || 'stable';
            if (typeof build !== 'string') {
                console.error("Invalid build: ".concat(build));
                process.exit(1);
            }
            dir = double['install-directory'] || single['d'] || (process.platform === 'linux'
                ? "/usr/share/code".concat(build === 'insiders' ? '-insiders' : '') :
                process.platform === 'win32'
                    ? path_1.default.join(process.env.LOCALAPPDATA, 'Programs', "Microsoft VS Code".concat(build === 'insiders' ? ' Insiders' : ''))
                    : path_1.default.join(process.env.HOME, 'Applications', "Visual Studio Code".concat(build === 'insiders' ? ' - Insiders' : '')));
            if (typeof dir !== 'string') {
                console.error("Invalid install directory: ".concat(dir));
                process.exit(1);
            }
            bindir = path_1.default.join(dir, 'bin');
            if (!fs_1.default.existsSync(bindir)) {
                console.error("Directory ".concat(bindir, " does not exist"));
                process.exit(1);
            }
            symlinkdir = double['symlink-directory']
                ? double['symlink-directory'] :
                single['s']
                    ? single['s'] :
                    (process.platform === 'linux' ? '/usr/bin' : path_1.default.join(process.env.HOME, 'bin'));
            if (typeof symlinkdir !== 'string') {
                console.error("Invalid symlink directory: ".concat(symlinkdir));
                process.exit(1);
            }
            if (!fs_1.default.existsSync(symlinkdir)) {
                console.error("Directory ".concat(symlinkdir, " does not exist"));
                process.exit(1);
            }
            console.log("Linking ".concat(bindir, " to ").concat(symlinkdir));
            if (process.platform === 'win32') {
                console.log('Link not needed on Windows');
                process.exit(0);
            }
            try {
                fs_1.default.accessSync(bindir, fs_1.default.constants.W_OK);
            }
            catch (error) {
                console.error("Directory ".concat(bindir, " is not writable, please run as root (sudo)"));
                process.exit(1);
            }
            if (!fs_1.default.readdirSync(bindir).includes("code".concat(build === 'insiders' ? '-insiders' : ''))) {
                console.error("File code".concat(build === 'insiders' ? '-insiders' : '', " does not exist"));
                process.exit(1);
            }
            fs_1.default.symlinkSync(path_1.default.join(bindir, "code".concat(build === 'insiders' ? '-insiders' : '')), path_1.default.join(symlinkdir, "code".concat(build === 'insiders' ? '-insiders' : '')), 'file');
            return [2 /*return*/];
        });
    });
}
function updateAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        var build, dir, bindir, execpath, version_3, versionfile, versionjson, versions, osname_1, platformVersion, file;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    build = double['build'] || single['b'] || 'stable';
                    if (typeof build !== 'string') {
                        console.error("Invalid build: ".concat(build));
                        process.exit(1);
                    }
                    dir = double['install-directory'] || single['d'] || (process.platform === 'linux'
                        ? "/usr/share/code".concat(build === 'insiders' ? '-insiders' : '') :
                        process.platform === 'win32'
                            ? path_1.default.join(process.env.LOCALAPPDATA, 'Programs', "Microsoft VS Code".concat(build === 'insiders' ? ' Insiders' : ''))
                            : path_1.default.join(process.env.HOME, 'Applications', "Visual Studio Code".concat(build === 'insiders' ? ' - Insiders' : '')));
                    if (typeof dir !== 'string') {
                        console.error("Invalid install directory: ".concat(dir));
                        process.exit(1);
                    }
                    if (!fs_1.default.existsSync(dir)) {
                        console.error("Directory ".concat(dir, " does not exist"));
                        process.exit(1);
                    }
                    bindir = path_1.default.join(dir, 'bin');
                    if (!fs_1.default.existsSync(bindir)) {
                        console.error("Directory ".concat(bindir, " does not exist"));
                        process.exit(1);
                    }
                    if (process.platform === 'linux') {
                        try {
                            fs_1.default.accessSync(bindir, fs_1.default.constants.W_OK);
                        }
                        catch (error) {
                            console.error("Directory ".concat(bindir, " is not writable, please run as root (sudo)"));
                            process.exit(1);
                        }
                    }
                    console.log("Updating ".concat(bindir));
                    if (!(process.platform === 'linux')) return [3 /*break*/, 4];
                    execpath = child_process_1.default.execSync('which code' + (build === 'insiders' ? '-insiders' : '')).toString().trim();
                    if (execpath === '') {
                        console.error("File code".concat(build === 'insiders' ? '-insiders' : '', " does not exist"));
                        process.exit(1);
                    }
                    version_3 = '';
                    if (build === 'stable') {
                        version_3 = child_process_1.default.execSync(execpath + ' --version').toString().trim().split('\n')[1].trim();
                    }
                    else {
                        versionfile = path_1.default.join(bindir, '..', 'resources', 'app', 'package.json');
                        versionjson = JSON.parse(fs_1.default.readFileSync(versionfile, 'utf8'));
                        version_3 = versionjson.distro;
                    }
                    return [4 /*yield*/, getVersions()];
                case 1:
                    versions = _a.sent();
                    osname_1 = "linux-".concat(process.arch);
                    platformVersion = versions
                        .find(function (v) { return v.platform.os === osname_1; });
                    if (!platformVersion) {
                        console.error("No version found for ".concat(osname_1));
                        process.exit(1);
                    }
                    if (platformVersion.version === version_3) {
                        console.log("Already up to date: ".concat(version_3));
                        process.exit(0);
                    }
                    return [4 /*yield*/, downloadAction(double, single)];
                case 2:
                    file = _a.sent();
                    return [4 /*yield*/, installAction(__assign(__assign({}, double), { file: file }), single)];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [2 /*return*/];
            }
        });
    });
}
function versionsAction(double, single) {
    return __awaiter(this, void 0, void 0, function () {
        var build, _a, stable, insiders, _b, currentStable, currentInsiders;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    build = double['build'] || single['b'] || 'all';
                    if (typeof build !== 'string') {
                        console.error("Invalid build: ".concat(build));
                        process.exit(1);
                    }
                    if (build !== 'all' && build !== 'stable' && build !== 'insiders') {
                        console.error("Invalid build: ".concat(build));
                        process.exit(1);
                    }
                    if (!(build === 'all')) return [3 /*break*/, 2];
                    return [4 /*yield*/, Promise.all([getLatestVersion('stable'), getLatestVersion('insider')])];
                case 1:
                    _a = _c.sent(), stable = _a[0], insiders = _a[1];
                    console.log("Latest Stable Version: ".concat(stable));
                    console.log("Latest Insiders Version: ".concat(insiders));
                    _b = version(), currentStable = _b.stable, currentInsiders = _b.insiders;
                    console.log("Current Stable Version: ".concat(currentStable));
                    console.log("Current Insiders Version: ".concat(currentInsiders));
                    _c.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (action === 'help') {
                helpAction(double, single);
            }
            else if (action === 'download') {
                downloadAction(double, single);
            }
            else if (action === 'install') {
                installAction(double, single);
            }
            else if (action === 'link') {
                linkAction(double, single);
            }
            else if (action === 'update') {
                updateAction(double, single);
            }
            else if (action === 'versions') {
                versionsAction(double, single);
            }
            return [2 /*return*/];
        });
    });
}
main();
//# sourceMappingURL=index.js.map